Endpoints for management of files
Hypatos REST API (2.51.0)
The Hypatos API is organized around REST. The majority of the endpoints provide CRUD functionality for resources. The API is also exposing Intent Resources which mimic user intents or actions.
The Hypatos API uses OAuth 2.0 Client Credential Grant to authenticate requests. Before making any requests to any endpoint a client must authenticate with the authorization server and requests an access token from the token endpoint.
POST /auth/token HTTP/1.1
Host: api.cloud.hypatos.ai
Content-Type: application/x-www-form-urlencoded
Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=
grant_type=client_credentialsAuthorization header contains client_id:client_secret encoded as explained in RFC Client Password section.
If the authorization server authenticated the client successfully, an access token is issued. Here is an example successful response:
HTTP/1.1 200 OK
Content-Type: application/json;charset=UTF-8
Cache-Control: no-store
Pragma: no-cache
{
"access_token": "mF_9.B5f-4.1JqM",
"expires_in": 86400,
"scope": "enrichment.write files.read",
"token_type": "Bearer",
}This token can be used to authenticate the requests to API endpoints by sending a Bearer token in the Authorization HTTP header. The following example demonstrates how to use the access token to retrieve a list of documents.
GET /v2/documents HTTP/1.1
Host: api.cloud.hypatos.ai
Authorization: Bearer mF_9.B5f-4.1JqMChanges to this API are released regularly. We use Semantic Versioning 2.0.0 scheme for versioning so that the clients can identify any backward-incompatible changes easily. Briefly summarized one can say, if the MAJOR version of the new API version didn't change you can expect the new version to be backward-compatible.
In order to maximise the stability of our API, we institue rate limits for all of API endpoints. Clients who send too many requests over a given period of time will see error responses that show up as status code 429 Too Many Requests.
When you see error responses with status code 429, it means you exhausted your current quota and need to withhold from sending further requests until the quota is reset. We encourage you not to wait until you get a 429 error but to monitor your quota in each request. In each response you receive from the API, you will find HTTP headers providing the details about your current quota. Here is the list of the HTTP headers:
x-ratelimit-limit: Indicates the quota associated to the client in the current time-window followed by the description of the quota policy.x-ratelimit-remaining: Indicates the number of remaining requests in the current time-windowx-ratelimit-reset: Indicates the number of seconds until quota reset of the current time-window
Please note that IETF is currently in the process of publishing a standard for these headers. Please explore the draft for more details.
A basic technique to gracefully handle rate limits is watch for your quota permanently and increase the time between your request as the quota is decreasing. To recover from a 429 error you need a retry mechanism following an exponential backoff schedule.
- API EUhttps://api.cloud.hypatos.ai/v2/enrichment/quotes/{externalId}
- API UShttps://api.cloud.hypatos.com/v2/enrichment/quotes/{externalId}
- Mock serverhttps://hypatos.redocly.app/_mock/openapi/enrichment/quotes/{externalId}
- curl
- Java
- Python
- Node.js
- JavaScript
curl -i -X DELETE \
'https://api.cloud.hypatos.ai/v2/enrichment/quotes/{externalId}' \
-H 'Authorization: Bearer <YOUR_TOKEN_HERE>'External id of the goods receipt that is globally unique across the provided goods receipt data
Identifier of the client entity in the source system which can be used to separate data
Document id that was assigned during upload to Hypatos
External unique id of the supplier in the source system
Label used in the source system for the fiscal year that the goods receipt was posted in
Date when the goods receipt was created in the source system
Delivery note number associated with the goods receipt
List of key value pairs containing custom fields from the source system
Any nested structure with metadata that source system needs to send
Number of the goods receipt line (unique within the purchase order)
Company ID associated with the line item.
ID of the related purchase order.
Line number of the purchase order being received.
Descriptive text for the line item.
Status of goods receipt line as defined in source system (e.g. “invoiced” or “open”)
List of key value pairs containing custom fields from the source system
- API EUhttps://api.cloud.hypatos.ai/v2/enrichment/goods-receipts
- API UShttps://api.cloud.hypatos.com/v2/enrichment/goods-receipts
- Mock serverhttps://hypatos.redocly.app/_mock/openapi/enrichment/goods-receipts
- curl
- Java
- Python
- Node.js
- JavaScript
curl -i -X POST \
https://api.cloud.hypatos.ai/v2/enrichment/goods-receipts \
-H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
-H 'Content-Type: application/json' \
-d '{
"externalId": "GOODS_RECEIPT-0001",
"externalClientId": "EXTERNAL_CLIENT_ID",
"documentId": "63cac12c37bb02accb396cbf",
"documents": [
{
"id": "63cac12c37bb02accb396cae",
"type": "invoice"
}
],
"goodsReceiptNumber": "GR123456789",
"externalCompanyId": "DE01",
"externalSupplierId": "0000100000",
"fiscalYearLabel": "2023",
"issuedDate": "2024-12-31",
"createdDate": "2025-06-30",
"postingDate": "2025-06-30",
"headerText": "doc header text",
"status": "POSTED",
"deliveryNoteNumber": "DN789456123",
"isReversal": false,
"customFields": {
"property1": "string",
"property2": "string"
},
"customMetadata": {
"someTopLevelProperty": "value1",
"someNestedProperty": {
"nestedProperty": "value2"
},
"someArrayProperty": [
"value3",
"value4"
]
},
"goodsReceiptLines": [
{
"goodsReceiptLineNumber": "GRLINE-0001",
"externalCompanyId": "DE01",
"externalPurchaseOrderId": "4500016221",
"purchaseOrderLineNumber": "00010",
"type": "Service",
"quantity": 2,
"unitOfMeasure": "kg",
"itemText": "Dell Laptop Latitude D630",
"status": "invoiced",
"material": {
"externalId": "2a6300181f08402e710ea3f180214bc1",
"supplierNumber": "123456789",
"type": "Operating Supplies",
"group": "Electronics",
"description": "Dell Laptop Latitude D630",
"manufacturer": "Acme Corporation",
"manufacturerNumber": "ACME-12345",
"unspsc": "43211508"
},
"plant": "PLANT-001",
"customFields": {
"property1": "string",
"property2": "string"
},
"customMetadata": {
"someTopLevelProperty": "value1",
"someNestedProperty": {
"nestedProperty": "value2"
},
"someArrayProperty": [
"value3",
"value4"
]
}
}
]
}'{ "id": "3a429dc8-56d4-42ef-a4cf-2ebc9ad1ef38" }
External id of the goods receipt that is globally unique across the provided goods receipt data
Identifier of the client entity in the source system which can be used to separate data
Document id that was assigned during upload to Hypatos
External unique id of the supplier in the source system
Label used in the source system for the fiscal year that the goods receipt was posted in
Date when the goods receipt was created in the source system
Delivery note number associated with the goods receipt
List of key value pairs containing custom fields from the source system
Any nested structure with metadata that source system needs to send
Number of the goods receipt line (unique within the purchase order)
Company ID associated with the line item.
ID of the related purchase order.
Line number of the purchase order being received.
Descriptive text for the line item.
Status of goods receipt line as defined in source system (e.g. “invoiced” or “open”)
List of key value pairs containing custom fields from the source system
- API EUhttps://api.cloud.hypatos.ai/v2/enrichment/goods-receipts/{externalId}
- API UShttps://api.cloud.hypatos.com/v2/enrichment/goods-receipts/{externalId}
- Mock serverhttps://hypatos.redocly.app/_mock/openapi/enrichment/goods-receipts/{externalId}
- curl
- Java
- Python
- Node.js
- JavaScript
curl -i -X PATCH \
'https://api.cloud.hypatos.ai/v2/enrichment/goods-receipts/{externalId}' \
-H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
-H 'Content-Type: application/merge-patch+json' \
-d '{
"externalId": "GOODS_RECEIPT-0001",
"externalClientId": "EXTERNAL_CLIENT_ID",
"documentId": "63cac12c37bb02accb396cbf",
"documents": [
{
"id": "63cac12c37bb02accb396cae",
"type": "invoice"
}
],
"goodsReceiptNumber": "GR123456789",
"externalCompanyId": "DE01",
"externalSupplierId": "0000100000",
"fiscalYearLabel": "2023",
"issuedDate": "2024-12-31",
"createdDate": "2025-06-30",
"postingDate": "2025-06-30",
"headerText": "doc header text",
"status": "POSTED",
"deliveryNoteNumber": "DN789456123",
"isReversal": false,
"customFields": {
"property1": "string",
"property2": "string"
},
"customMetadata": {
"someTopLevelProperty": "value1",
"someNestedProperty": {
"nestedProperty": "value2"
},
"someArrayProperty": [
"value3",
"value4"
]
},
"goodsReceiptLines": [
{
"goodsReceiptLineNumber": "GRLINE-0001",
"externalCompanyId": "DE01",
"externalPurchaseOrderId": "4500016221",
"purchaseOrderLineNumber": "00010",
"type": "Service",
"quantity": 2,
"unitOfMeasure": "kg",
"itemText": "Dell Laptop Latitude D630",
"status": "invoiced",
"material": {
"externalId": "2a6300181f08402e710ea3f180214bc1",
"supplierNumber": "123456789",
"type": "Operating Supplies",
"group": "Electronics",
"description": "Dell Laptop Latitude D630",
"manufacturer": "Acme Corporation",
"manufacturerNumber": "ACME-12345",
"unspsc": "43211508"
},
"plant": "PLANT-001",
"customFields": {
"property1": "string",
"property2": "string"
},
"customMetadata": {
"someTopLevelProperty": "value1",
"someNestedProperty": {
"nestedProperty": "value2"
},
"someArrayProperty": [
"value3",
"value4"
]
}
}
]
}'Successfully updated
External id of the goods receipt that is globally unique across the provided goods receipt data
Identifier of the client entity in the source system which can be used to separate data
Document id that was assigned during upload to Hypatos
External unique id of the supplier in the source system
Label used in the source system for the fiscal year that the goods receipt was posted in
Date when the goods receipt was created in the source system
Delivery note number associated with the goods receipt
List of key value pairs containing custom fields from the source system
Any nested structure with metadata that source system needs to send
Number of the goods receipt line (unique within the purchase order)
Company ID associated with the line item.
ID of the related purchase order.
Line number of the purchase order being received.
Descriptive text for the line item.
Status of goods receipt line as defined in source system (e.g. “invoiced” or “open”)
List of key value pairs containing custom fields from the source system
{ "externalId": "GOODS_RECEIPT-0001", "externalClientId": "EXTERNAL_CLIENT_ID", "documentId": "63cac12c37bb02accb396cbf", "documents": [ { … } ], "goodsReceiptNumber": "GR123456789", "externalCompanyId": "DE01", "externalSupplierId": "0000100000", "fiscalYearLabel": "2023", "issuedDate": "2024-12-31", "createdDate": "2025-06-30", "postingDate": "2025-06-30", "headerText": "doc header text", "status": "POSTED", "deliveryNoteNumber": "DN789456123", "isReversal": false, "customFields": { "property1": "string", "property2": "string" }, "customMetadata": { "someTopLevelProperty": "value1", "someNestedProperty": { … }, "someArrayProperty": [ … ] }, "goodsReceiptLines": [ { … } ] }